local L = LibStub("AceLocale-3.0"):GetLocale("GigaItemAuction", false)

local candy = AceLibrary("CandyBar-2.0")

local _G				= getfenv(0)

local pairs			    = _G.pairs
local ipairs			= _G.ipairs
local select			= _G.select

local table_insert		= _G.table.insert
local table_remove		= _G.table.remove
local table_sort		= _G.table.sort

local anchor = "GIAFrame"

local PLAYERNAME = UnitName("player")
local PLAYERGUID = 0

local db

local function getGameTimeAsUnix()
	return time()
end

local function getCurrentDate(timestamp, short)
   local dt = date("*t", timestamp)
   if short then
      return string.format("%02d:%02d:%02d", dt.hour, dt.min, dt.sec)
   else
      return string.format("%02d/%02d/%d - %02d:%02d:%02d", dt.day , dt.month, dt.year, dt.hour, dt.min, dt.sec)
   end
end


function GigaItemAuction:FRAMEOnInitialize()
	db = self.db.profile
end

function GigaItemAuction:OnHyperlinkEnter()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	if dbn.itemLink and dbn.itemLink ~= "" then
		ShowUIPanel(GameTooltip)
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(dbn.itemLink)
		GameTooltip:Show()
	end
end

function GigaItemAuction:OnHyperlinkLeave()
	HideUIPanel(GameTooltip)
end

function GigaItemAuction:CreateAUCTIONFrame()
	PLAYERGUID 	= tonumber(UnitGUID("player"), 16)
    
	if self.AUCTIONFrame then return end
	
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	local sfont = "Interface\\AddOns\\GigaItemAuction\\textures\\FRIZQT__.TTF"
	
	self.AUCTIONFrame = CreateFrame("Frame", anchor, UIParent)
    local f = self.AUCTIONFrame
    f:SetResizable(false)
    f:SetMovable(true)
    f:SetWidth(215)
    f:SetHeight(225)
	f:SetBackdrop({
		bgFile = "Interface\\AddOns\\GigaItemAuction\\textures\\main_bg",		
		insets = { left = 0, right = -40, top = 0, bottom = -30 },
		TileSize = 256, edgeSize = 0,
	})
	f:SetScale(1.0)
    f:EnableMouse(true)
    f:ClearAllPoints()
    f:SetScript("OnMouseDown", function() f:StartMoving(); end)
    f:SetScript("OnMouseUp", function() f:StopMovingOrSizing(); self:SavePosition(self.AUCTIONFrame) end)
	f:SetPoint(db.position.point, "UIParent", db.position.relpoint, db.position.x, db.position.y)
	
--~ 	Titel
	f.Title = f:CreateFontString("GIA_Title", "HIGH")
    f.Title:SetFont(sfont, 14, "OUTLINE")
    f.Title:SetText("")
    f.Title:SetPoint("TOPRIGHT", f, "TOPLEFT", 210, -90)
	
--~     closeButton
    f.closeButton = CreateFrame("Button", nil, f, "UIPanelCloseButton")
    f.closeButton:SetPoint("TOPLEFT", f, "TOPLEFT", 196, -2)
    f.closeButton:SetWidth(16)
    f.closeButton:SetHeight(16)
    f.closeButton:SetNormalTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_close")
    f.closeButton:SetPushedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_close_pushed")
    f.closeButton:SetScript("OnClick", function() self:StopStatusbar() self:HideAUCTIONFrame() end)
	
--~     adminButton
    f.adminButton = CreateFrame("Button", nil, f, "UIPanelButtonTemplate")
    f.adminButton:SetPoint("RIGHT", f.closeButton, "LEFT", -5, 0)
    f.adminButton:SetWidth(26)
    f.adminButton:SetHeight(16)  
    f.adminButton:SetText("ACP") 
	f.adminButton:RegisterForClicks("AnyUp")
    f.adminButton:SetScript("OnClick", function() self:ToggleADMINFrame() end)
	f.adminButton:Hide()

	
--~ 	ItemIcon
	f.itemIcon = CreateFrame("Button", nil, f)
    f.itemIcon:SetNormalTexture("")
    f.itemIcon:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square")
    f.itemIcon:SetPoint("TOPLEFT", f, "TOPLEFT", 10, -26)
    f.itemIcon:SetHeight(32)
    f.itemIcon:SetWidth(32)
	f.itemIcon:SetScript("OnEnter",function() self:OnHyperlinkEnter() end)
	f.itemIcon:SetScript("OnLeave",function() self:OnHyperlinkLeave() end)
	
--~ 	ItemName
	f.itemName = f:CreateFontString("GIA_itemName", "HIGH")
    f.itemName:SetFont(sfont, 14, "OUTLINE")
    f.itemName:SetText("-")
    f.itemName:SetPoint("TOPLEFT", f.itemIcon, "TOPRIGHT", 10, 0)
    f.itemName:SetWidth(153)
    f.itemName:SetHeight(14)
    f.itemName:SetJustifyH("LEFT")
	
--~ 	ItemExtra
	f.itemName2 = f:CreateFontString("GIA_itemName2", "HIGH")
    f.itemName2:SetFont(sfont, 14, "OUTLINE")
    f.itemName2:SetText("-")
    f.itemName2:SetPoint("BOTTOMLEFT", f.itemIcon, "BOTTOMRIGHT", 10, 0)
    f.itemName2:SetWidth(153)
    f.itemName2:SetHeight(14)
    f.itemName2:SetJustifyH("LEFT")
    f.itemName2:SetTextColor(unpack(self.colors.white))


--~ 	StatusBar
	candy:RegisterCandyBarGroup(anchor)
	candy:SetCandyBarGroupPoint(anchor, "TOPLEFT", f, "TOPLEFT", -20, -66)
	candy:SetCandyBarGroupGrowth(anchor, false)
	
--~ 	AktuellerPreisTitel
	f.AktuellerPreisTitel = f:CreateFontString("GIA_AktuellerPreisTitel", "HIGH")
    f.AktuellerPreisTitel:SetFont(sfont, 14)
    f.AktuellerPreisTitel:SetText(L["Current price:"])
    f.AktuellerPreisTitel:SetPoint("TOPLEFT", f, "TOPLEFT", 10, -100)
    f.AktuellerPreisTitel:SetTextColor(unpack(self.colors.black))
--~ 	AktuellerPreis
	f.AktuellerPreis = f:CreateFontString("GIA_AktuellerPreis", "HIGH")
    f.AktuellerPreis:SetFont(sfont, 24, "OUTLINE")
    f.AktuellerPreis:SetText("0")
    f.AktuellerPreis:SetPoint("LEFT", f.AktuellerPreisTitel, "RIGHT", 5, 0)
    f.AktuellerPreis:SetTextColor(unpack(self.colors.neutral))
	
--~ 	HoechstbieterTitel
	f.HoechstbieterTitel = f:CreateFontString("GIA_HoechstbieterTitel", "HIGH")
    f.HoechstbieterTitel:SetFont(sfont, 14)
    f.HoechstbieterTitel:SetText(L["Highest bidder:"])
    f.HoechstbieterTitel:SetPoint("TOPLEFT", f, "TOPLEFT", 10, -125)
    f.HoechstbieterTitel:SetTextColor(unpack(self.colors.black))	
--~ 	Hoechstbieter
	f.Bieter = f:CreateFontString("GIA_Hoechstbieter", "HIGH")
    f.Bieter:SetFont(sfont, 24, "OUTLINE")
    f.Bieter:SetText("-")
    f.Bieter:SetPoint("LEFT", f.HoechstbieterTitel, "RIGHT", 5, 0)
    f.Bieter:SetTextColor(unpack(self.colors.neutral))
	
--~ 	Bietart
	f.Bietart = f:CreateFontString("GIA_Bieten", "HIGH")
    f.Bietart:SetFont(sfont, 14)
    f.Bietart:SetText(L["Bidmode:"])
    f.Bietart:SetPoint("TOPLEFT", f, "TOPLEFT", 10, -150)
    f.Bietart:SetTextColor(unpack(self.colors.black))
	
--~ 	Bieten
	f.Bieten = f:CreateFontString("GIA_Bieten", "HIGH")
    f.Bieten:SetFont(sfont, 14)
    f.Bieten:SetText(L["Bid:"])
    f.Bieten:SetPoint("TOPLEFT", f, "TOPLEFT", 10, -175)
    f.Bieten:SetTextColor(unpack(self.colors.black))
	
--~ 	BietenButtons	
	--~ 	Button 4
		f.Bid4 = CreateFrame("Button", nil, f, "UIPanelCloseButton")
		f.Bid4:SetPoint("TOPLEFT", f, "TOPLEFT", 175, -165)
		f.Bid4:SetWidth(32)
		f.Bid4:SetHeight(32)	
		f.Bid4:SetNormalTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid")
		f.Bid4:SetPushedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid_pushed")
		f.Bid4:SetDisabledTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid_disabled")
		f.Bid4:RegisterForClicks("AnyUp")
		f.Bid4:SetScript("OnClick", function() self:SetButtonDisable() self:SendBidpoint(self.AUCTIONFrame.Bid4Text:GetText()) end)
		f.Bid4:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
		f.Bid4:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
			GameTooltip:AddLine("|cffffffff+|cff55ff55 "..dbc.bidStep.step4.." |cffffffffdkp|r")
			GameTooltip:Show()
		end)
	
			f.Bid4Text = f.Bid4:CreateFontString("GIA_Bid4Text", "HIGH")
			f.Bid4Text:SetFont(sfont, 14, "OUTLINE")
			f.Bid4Text:SetText("50")
			f.Bid4Text:SetPoint("CENTER", f.Bid4, "CENTER",1,1.5)
			f.Bid4Text:SetTextColor(unpack(self.colors.white))
		
	--~ 	Button 3
		f.Bid3 = CreateFrame("Button", nil, f, "UIPanelCloseButton")
		f.Bid3:SetPoint("RIGHT", f.Bid4, "LEFT", -4, 0)
		f.Bid3:SetWidth(32)
		f.Bid3:SetHeight(32)	
		f.Bid3:SetNormalTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid")
		f.Bid3:SetPushedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid_pushed")
		f.Bid3:SetDisabledTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid_disabled")
		f.Bid3:RegisterForClicks("AnyUp")
		f.Bid3:SetScript("OnClick", function() self:SetButtonDisable() self:SendBidpoint(self.AUCTIONFrame.Bid3Text:GetText()) end)
		f.Bid3:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
		f.Bid3:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
			GameTooltip:AddLine("|cffffffff+|cff55ff55 "..dbc.bidStep.step3.." |cffffffffdkp|r")
			GameTooltip:Show()
		end)
		
			f.Bid3Text = f.Bid3:CreateFontString("GIA_Bid4Text", "HIGH")
			f.Bid3Text:SetFont(sfont, 14, "OUTLINE")
			f.Bid3Text:SetText("25")
			f.Bid3Text:SetPoint("CENTER", f.Bid3, "CENTER",1,1.5)
			f.Bid3Text:SetTextColor(unpack(self.colors.white))
		
	--~ 	Button 2	
		f.Bid2 = CreateFrame("Button", nil, f, "UIPanelCloseButton")
		f.Bid2:SetPoint("RIGHT", f.Bid3, "LEFT", -4, 0)
		f.Bid2:SetWidth(32)
		f.Bid2:SetHeight(32)	
		f.Bid2:SetNormalTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid")
		f.Bid2:SetPushedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid_pushed")
		f.Bid2:SetDisabledTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid_disabled")
		f.Bid2:RegisterForClicks("AnyUp")
		f.Bid2:SetScript("OnClick", function() self:SetButtonDisable() self:SendBidpoint(self.AUCTIONFrame.Bid2Text:GetText()) end)
		f.Bid2:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
		f.Bid2:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
			GameTooltip:AddLine("|cffffffff+|cff55ff55 "..dbc.bidStep.step2.." |cffffffffdkp|r")
			GameTooltip:Show()
		end)
		
			f.Bid2Text = f.Bid2:CreateFontString("GIA_Bid4Text", "HIGH")
			f.Bid2Text:SetFont(sfont, 14, "OUTLINE")
			f.Bid2Text:SetText("10")
			f.Bid2Text:SetPoint("CENTER", f.Bid2, "CENTER",1,1.5)
			f.Bid2Text:SetTextColor(unpack(self.colors.white))
		
	--~ 	Button 1
		f.Bid1 = CreateFrame("Button", nil, f, "UIPanelCloseButton")
		f.Bid1:SetPoint("RIGHT", f.Bid2, "LEFT", -4, 0)
		f.Bid1:SetWidth(32)
		f.Bid1:SetHeight(32)	
		f.Bid1:SetNormalTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid")
		f.Bid1:SetPushedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid_pushed")
		f.Bid1:SetDisabledTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_bid_disabled")
		f.Bid1:RegisterForClicks("AnyUp")
		f.Bid1:SetScript("OnClick", function() self:SetButtonDisable() self:SendBidpoint(self.AUCTIONFrame.Bid1Text:GetText()) end)
		f.Bid1:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
		f.Bid1:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
			GameTooltip:AddLine("|cffffffff+|cff55ff55 "..dbc.bidStep.step1.." |cffffffffdkp|r")
			GameTooltip:Show()
		end)
		
			f.Bid1Text = f.Bid1:CreateFontString("GIA_Bid4Text", "HIGH")
			f.Bid1Text:SetFont(sfont, 14, "OUTLINE")
			f.Bid1Text:SetText("5")
			f.Bid1Text:SetPoint("CENTER", f.Bid1, "CENTER",1,1.5)
			f.Bid1Text:SetTextColor(unpack(self.colors.white))
	
	
--~ 	Bieten Extras
	f.BietenX = f:CreateFontString("GIA_BietenX", "HIGH")
    f.BietenX:SetFont(sfont,14)
    f.BietenX:SetText(L["Special action:"])
    f.BietenX:SetPoint("TOPLEFT", f, "TOPLEFT", 10, -200)
    f.BietenX:SetTextColor(unpack(self.colors.black))
	--~ 	Bieten Extras Buttons
		f.BidBreak = CreateFrame("Button", nil, f, "UIPanelCloseButton")
		f.BidBreak:SetPoint("TOPRIGHT", f, "TOPLEFT", 207, -200)
		f.BidBreak:SetWidth(128)
		f.BidBreak:SetHeight(16)
		f.BidBreak:SetNormalTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_wathdraw")
		f.BidBreak:SetPushedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_wathdraw_pushed")
		f.BidBreak:SetDisabledTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_wathdraw_disabled")
		f.BidBreak:SetScript("OnClick", function() this:Disable() self:SendPassLastBid() end)
		
			f.BidBreakText = f.BidBreak:CreateFontString("GIA_Bid4Text", "HIGH")
			f.BidBreakText:SetFont(sfont, 12)
			f.BidBreakText:SetText(L["Withdraw bid"])
			f.BidBreakText:SetPoint("CENTER", f.BidBreak, "CENTER",10,0.5)
			f.BidBreakText:SetTextColor(unpack(self.colors.red_dark))
	
	self:CreateBidArtRadio()

	self:SetButtonDisable()
	self:SetBreakButtonDisable()
end


------------------------------------------------------------------
-- SetRadio
------------------------------------------------------------------
function GigaItemAuction:CreateBidArtRadio()
	local f = self.AUCTIONFrame
    local t = self.BidArt
	
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
--~     RadioButtons  
    if not f.Radio then f.Radio = {} end
    if not f.RadioText then f.RadioText = {} end
	local sfont = "Interface\\AddOns\\GigaItemAuction\\textures\\FRIZQT__.TTF"
--~     Main > Main u80 > 2nd Skillung > 2nd Skillung u80 > Fun > Fun u80
    for i = 1, 3 do
        f.Radio[i] = CreateFrame("CheckButton", "GIARadio"..i.."Setup", f, "UICheckButtonTemplate")
		f.Radio[i]:SetNormalTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_radio")
		f.Radio[i]:SetPushedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_radio")
		f.Radio[i]:SetDisabledTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_radio_disabled")
		f.Radio[i]:SetDisabledCheckedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_radio_checked_disabled")
		f.Radio[i]:SetCheckedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_radio_checked")
		f.Radio[i]:SetWidth(16)
		f.Radio[i]:SetHeight(16)
        f.RadioText[i] = f:CreateFontString("GIARadio"..i.."FrameTitle", "HIGH")
		
        if i == 1 then
            f.Radio[i]:SetPoint("BOTTOM", f.Bid1, "TOP", -7, 0)
        else
            f.Radio[i]:SetPoint("LEFT", f.Radio[i-1], "RIGHT", i==2 and 19 or 17, 0)
        end
		
		if dbc.bidArt == t.kurz[i] then            
            f.Radio[i]:SetChecked(true)
		end
        
        f.Radio[i]:SetScript("OnClick", function() self:ToggleBidArtRadio(i) end)
		f.Radio[i]:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
			GameTooltip:AddLine(t.lang[i])
			GameTooltip:Show()
		end)
		f.Radio[i]:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
        f.Radio[i]:SetText(i)
		
        f.RadioText[i]:SetPoint("LEFT", f.Radio[i], "RIGHT", 0, 0)
        f.RadioText[i]:SetFont(sfont,14, "OUTLINE")
        f.RadioText[i]:SetText(t.kurz[i])
        f.RadioText[i]:SetTextColor(unpack(self.colors.white))
    end
	
	f.CheckU80 = CreateFrame("CheckButton", "GIACheckSetup", f, "UICheckButtonTemplate")
	f.CheckU80:SetNormalTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_check")
    f.CheckU80:SetPushedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_check")
	f.CheckU80:SetDisabledTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_check_disabled")
	f.CheckU80:SetDisabledCheckedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_check_checked_disabled")
	f.CheckU80:SetCheckedTexture("Interface\\AddOns\\GigaItemAuction\\textures\\button_check_checked")
	f.CheckU80:SetPoint("LEFT", f.Radio[3], "RIGHT", 18, -1)
	f.CheckU80:SetScript("OnClick", function() self:ToggleBidU80() end)
	f.CheckU80:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
		GameTooltip:AddLine(t.lang[4])
		GameTooltip:Show()
	end)
	f.CheckU80:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	f.CheckU80:SetChecked(dbc.bidU80 and true or false)
    f.CheckU80:SetWidth(16)
    f.CheckU80:SetHeight(16)
	
	f.CheckU80Text = f:CreateFontString("GIACheckFrameTitle", "HIGH")
	f.CheckU80Text:SetPoint("LEFT", f.CheckU80, "RIGHT", 0, 1)
	f.CheckU80Text:SetFont(sfont,14, "OUTLINE")
	f.CheckU80Text:SetText(t.kurz[4])
	f.CheckU80Text:SetTextColor(unpack(self.colors.white))
	
end

function GigaItemAuction:ToggleBidU80()
	local f = self.AUCTIONFrame
	
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	if dbc.bidU80 then
		dbc.bidU80 = false
	else
		dbc.bidU80 = true
	end
	f.CheckU80:SetChecked(dbc.bidU80 and true or false)
	
	self:SetAuctionBidStats()
end

function GigaItemAuction:ToggleBidArtRadio(radio)
	local f = self.AUCTIONFrame
    local t = self.BidArt
	
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
    for j = 1, 3 do
        f.Radio[j]:SetChecked(false)
    end
    
    for i = 1, 3 do
        if radio == i then
            f.Radio[i]:SetChecked(true)
            dbc.bidArt = tostring(t.kurz[i])
        end
    end
	
	self:SetAuctionBidStats()
end

----------------------------------------------------------
--~ Status Bar
function GigaItemAuction:StartStatusBar(time)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	candy:RegisterCandyBar("GIA_BidTime", time and time or dba.bidTime, L["statusbar_text_start"], nil, unpack({ "blue", "green", "red", }) )
	candy:RegisterCandyBarWithGroup("GIA_BidTime", anchor)
	candy:SetCandyBarTexture("GIA_BidTime", "Interface\\AddOns\\GigaItemAuction\\textures\\bantobar.tga")
	candy:SetCandyBarWidth("GIA_BidTime", 215)
	candy:SetCandyBarHeight("GIA_BidTime", 20)
	candy:SetCandyBarScale("GIA_BidTime", 1.0)
	candy:SetCandyBarFontSize("GIA_BidTime", 14)
	candy:StartCandyBar("GIA_BidTime", true)
end

function GigaItemAuction:StopStatusbar()
	candy:StopCandyBar("GIA_BidTime")
	candy:UnregisterCandyBar("GIA_BidTime")
end

function GigaItemAuction:PauseStatusbar()
--~ 	self:StopStatusbar()
	candy:PauseCandyBar("GIA_BidTime")
end

function GigaItemAuction:SetStatusbarText(text)
	candy:SetCandyBarText("GIA_BidTime", text)
end
----------------------------------------------------------
--~ Show/Hide/Save Window
function GigaItemAuction:ToggleAUCTIONFrame()
    if self.AUCTIONFrame:IsVisible() then
        self:HideAUCTIONFrame()
    else
        self:ShowAUCTIONFrame()
    end
end

function GigaItemAuction:ShowAUCTIONFrame()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	if not dbn.auctionAuthor or dbn.auctionAuthor == "" then
		self:SetAuctionStats()
		self:SetButtonDisable()
		self:SetBreakButtonDisable()
		self.AUCTIONFrame.itemIcon:SetNormalTexture("")
		self.AUCTIONFrame.itemName:SetText("")
		self.AUCTIONFrame.itemName2:SetText("")
	end
	
    self.AUCTIONFrame:Show()
	
	if self:CheckPriority(PLAYERNAME) then
		self.AUCTIONFrame.adminButton:Show()
	else
		self.AUCTIONFrame.adminButton:Hide()
		self:HideADMINFrame()
	end
	
    dbc.showAuctionWindow = true
end

function GigaItemAuction:HideAUCTIONFrame()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
    self.AUCTIONFrame:Hide()
    dbc.showAuctionWindow = false
end

function GigaItemAuction:SetButtonDisable()
	self.AUCTIONFrame.Bid1:Disable()
	self.AUCTIONFrame.Bid2:Disable()
	self.AUCTIONFrame.Bid3:Disable()
	self.AUCTIONFrame.Bid4:Disable()
	self.AUCTIONFrame.Bid1Text:SetTextColor(unpack(self.colors.neutral))
	self.AUCTIONFrame.Bid2Text:SetTextColor(unpack(self.colors.neutral))
	self.AUCTIONFrame.Bid3Text:SetTextColor(unpack(self.colors.neutral))
	self.AUCTIONFrame.Bid4Text:SetTextColor(unpack(self.colors.neutral))
end
function GigaItemAuction:SetButtonEnable()
	self.AUCTIONFrame.Bid1:Enable()
	self.AUCTIONFrame.Bid2:Enable()
	self.AUCTIONFrame.Bid3:Enable()
	self.AUCTIONFrame.Bid4:Enable()
	self.AUCTIONFrame.Bid1Text:SetTextColor(unpack(self.colors.white))
	self.AUCTIONFrame.Bid2Text:SetTextColor(unpack(self.colors.white))
	self.AUCTIONFrame.Bid3Text:SetTextColor(unpack(self.colors.white))
	self.AUCTIONFrame.Bid4Text:SetTextColor(unpack(self.colors.white))
end
function GigaItemAuction:SetBreakButtonDisable()
	self.AUCTIONFrame.BidBreak:Disable()
	self.AUCTIONFrame.BidBreakText:SetTextColor(unpack(self.colors.neutral))
end
function GigaItemAuction:SetBreakButtonEnable()
	if not db.admin.bidWithdraw then return end
	self.AUCTIONFrame.BidBreak:Enable()
	self.AUCTIONFrame.BidBreakText:SetTextColor(unpack(self.colors.red_dark))
end
function GigaItemAuction:SetBreakButtonUpdate()
	if not db.admin.bidWithdraw then
		self:SetBreakButtonDisable()
	elseif db.nowAuction.last.BidName == PLAYERGUID then
		self:SetBreakButtonEnable()
	end
end
function GigaItemAuction:SetAllButtonDisable()
	self:SetButtonDisable()
	self:SetBreakButtonDisable()
end
function GigaItemAuction:SetAllButtonEnable()
	self:SetButtonEnable()
	self:SetBreakButtonEnable()
end

function GigaItemAuction:SyncBidArt()
	local dba = db.admin
	local s = {}
	s.kurz, s.kula = L["u80_mini"]:format(dba.bidUP), L["u80"]:format(dba.bidUP)
	self.BidArt = {
		kurz = {"M","S","F",s["kurz"]},
		lang = {"Main", "Second", "Fun", s["kula"]},
		kula = {
			["M"] = "Main", 
			["S"] = "Second", 
			["F"] = "Fun", 
			[s["kurz"]] = s["kula"],
		}
	}
end

function GigaItemAuction:SyncButtonsWithDatabase()
	local f = self.AUCTIONFrame
	local a = self.ADMINFrame
    local t = self.BidArt
	local sfont = "Interface\\AddOns\\GigaItemAuction\\textures\\FRIZQT__.TTF"
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	self:SyncBidArt()
	
	if dba.bidArt.main then
		f.Radio[1]:Enable()
        f.RadioText[1]:SetTextColor(unpack(self.colors.white))		
	else
		f.Radio[1]:Disable()
        f.RadioText[1]:SetTextColor(unpack(self.colors.neutral))	
	end
	
	if dba.bidArt.second then
		f.Radio[2]:Enable()
        f.RadioText[2]:SetTextColor(unpack(self.colors.white))		
	else
		f.Radio[2]:Disable()
        f.RadioText[2]:SetTextColor(unpack(self.colors.neutral))	
	end
	
	if dba.bidArt.fun then
		f.Radio[3]:Enable()
        f.RadioText[3]:SetTextColor(unpack(self.colors.white))		
	else
		f.Radio[3]:Disable()
        f.RadioText[3]:SetTextColor(unpack(self.colors.neutral))	
	end
	
	if dba.bidArt.u80 then
		f.CheckU80:Enable()
        f.CheckU80Text:SetTextColor(unpack(self.colors.white))		
	else
		f.CheckU80:Disable()
        f.CheckU80Text:SetTextColor(unpack(self.colors.neutral))
		
		dbc.bidU80 = false
		f.CheckU80:SetChecked(dbc.bidU80 and true or false)
	end
	f.CheckU80Text:SetText(t.kurz[4])
	f.CheckU80:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT");
		GameTooltip:AddLine(t.lang[4])
		GameTooltip:Show()
	end)
	
	if dba.bidWithdraw then
		a.RadioWithdraw[1]:SetChecked(true)
		a.RadioWithdraw[2]:SetChecked(false)
	else
		a.RadioWithdraw[1]:SetChecked(false)
		a.RadioWithdraw[2]:SetChecked(true)
	end
	
	if dba.bidderShow then
		a.RadioHighestBidder[1]:SetChecked(false)
		a.RadioHighestBidder[2]:SetChecked(true)
	else
		a.RadioHighestBidder[1]:SetChecked(true)
		a.RadioHighestBidder[2]:SetChecked(false)
	end
	
	if dbc.bidStep.step1 ~= dba.bidStep then
		dbc.bidStep.step1 = dba.bidStep
	end
	
	if dbc.bidStep.step2 < dba.bidStep then
		dbc.bidStep.step2 = dba.bidStep * 2
	end
	
	if dbc.bidStep.step3 < dba.bidStep then
		dbc.bidStep.step3 = dba.bidStep * 5
	end
	
	if dbc.bidStep.step4 < dba.bidStep then
		dbc.bidStep.step4 = dba.bidStep * 10
	end
	
	self:SetAuctionBidStats()
	
	a.timeSlider:SetValue(dba.bidTime)
end

function GigaItemAuction:SavePosition(frame)
	local point, _, relpoint, pointx, pointy = frame:GetPoint()
	db.position.point = point
	db.position.relpoint = relpoint
	db.position.x = pointx
	db.position.y = pointy
end