﻿local L = LibStub("AceLocale-3.0"):GetLocale("GigaItemAuction", false)

local _G				= getfenv(0)

local pairs			    = _G.pairs
local ipairs			= _G.ipairs
local select			= _G.select

local table_insert		= _G.table.insert
local table_remove		= _G.table.remove
local table_sort		= _G.table.sort

local PLAYERNAME 		= UnitName("player")
local _, PLAYERCLASS 	= UnitClass("player")
local PLAYERGUID 		= 0

local db

local falseVersionMSG 		= false


function GigaItemAuction:SYNCOnInitialize()
	db = self.db.profile
	self:RegisterComm(self.amsg.prefix, "OnCommReceive")
end

local function splitMessage(msg)
	return strsplit(" ",msg)
end

function GigaItemAuction:OnCommReceive(prefix, value, typ, author)
	if prefix ~= self.amsg.prefix then return end
	if typ ~= "GUILD" and typ ~= "RAID" and typ ~= "WHISPER" then return end
	
	PLAYERGUID 		= tonumber(UnitGUID("player"), 16)
	
	local worked, key 	= self:Deserialize(value)
	local addonMSG 		= self.amsg.key
	
	local cauthor = self:GetColoredName(author)
	
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	if not worked then
		local broken_key, broken_value = splitMessage(value)
		if (dbc.debugmodus or dbc.debugadmin) and broken_key ~= addonMSG.revision then
			self:Print(L["syncerror1"]:format(cauthor))
		end
		return
	end
	
	
	if typ == "GUILD" or typ == "RAID" then
	
--~ Gebot kommt an
		if key == addonMSG.sendtruebid then	
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Bid true. ["..cauthor.."]")
			end
			
			self:NewBidAuction(value, author)
--~ Versteigerung beendet
		elseif key == addonMSG.sendendauction then
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction end. ["..cauthor.."]")
			end
			
			self:StopAuction(value, author)
--~ Versteigerung abgebrochen
		elseif key == addonMSG.breakauction then
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction break. ["..cauthor.."]")
			end
			
			self.auctionAdminBreak = author
			self:StopAuction(self.auctionAdminBreak, author)
--~ Versteigerung verlängern
		elseif key == addonMSG.auctionlong then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Current auction bidtime edit. ["..cauthor.."]")
			end
			
			self:AdminAuctionLonger(author, self.auctionStatusSTART)
			
--~ Versteigerungszeit geaendert
		elseif key == addonMSG.newbidtime then			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Edit bidtime by ["..cauthor.."]")
			end
			
			self:AdminEditBidTimeByAdmin(value, author)
			
--~ Raid version check
		elseif key == addonMSG.sendversioncheck then
			
			self:SendAddonMSG(self:Serialize(addonMSG.getversioncheck, self.revision, PLAYERCLASS, PLAYERNAME, self:CheckPriority(PLAYERNAME), dba.bidTime), "WHISPER", author)
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r SEND - My version send to ["..cauthor.."].")
			end
			
--~ Version testing
		elseif key == addonMSG.revision then
			_, _, value = self:Deserialize(value)
			
			if tonumber(value) > tonumber(self.revision) and tonumber(value) > tonumber(self.revisionNEW) then
				self.AUCTIONFrame.Title:SetText("|cffff0000"..L["NEW"].."|r |cffffffffr"..value.."|r")
				self.revisionNEW = tonumber(value)
				if not falseVersionMSG then
					self:Print(L["hinweis4"])
					falseVersionMSG = true
				end
			else
				self.AUCTIONFrame.Title:SetText("")
			end
			
			if dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - ["..cauthor.."] send version. r"..value)
			end
			
--~ Start Auction
		elseif key == addonMSG.sendstartauction then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction started by ["..cauthor.."].")
			end
			
			self:PauseStartAuction(author, true)
			
--~ Pause Auction
		elseif key == addonMSG.sendpauseauction then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction paused by ["..cauthor.."].")
			end
			
			self:PauseStartAuction(author, false)
			
--~ Reset Auction
		elseif key == addonMSG.sendresetauction then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Auction reset by ["..cauthor.."].")
			end
			
			self:ResetAuction(author)
			
--~ Withdraw option
		elseif key == addonMSG.sendwithdraw then
			_, _, value = self:Deserialize(value)
			dba.bidWithdraw = value
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Bid withdraw mode edit by ["..cauthor.."]. Value: "..(value and 'approve' or 'block'))
			end
			
			self:SetBreakButtonUpdate()
			
--~ Highest bidder option
		elseif key == addonMSG.sendanonym then
			_, _, value = self:Deserialize(value)
			dba.bidderShow = value
			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Highest bidder showmode edit by ["..cauthor.."]. Value: "..(value and 'visible' or 'anonym'))
			end
			
--~ Error incoming
		elseif key == addonMSG.sendfalsebid then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Error-/Hintreport by ["..cauthor.."].")
			end
			
			_, _, value = self:Deserialize(value)			
			self:FalseBidAuction(value, author)
			
--~ Wenn Bietzeit anders ist, dann aktuallisieren
		elseif key == addonMSG.sendbidtime then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Response current Auction from ["..cauthor.."].")
			end
			
			self:AdminCurrentAuctionSync(value, author)
			
			
		end
		
		
		
	elseif typ == "WHISPER" then
--~ Raid version incoming
		if key == addonMSG.getversioncheck then
			self:VersionShowAll(value)
			
--~ Wenn Bietzeit anders ist, dann aktuallisieren
		elseif key == addonMSG.sendbidtime then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Response current Auction from ["..cauthor.."].")
			end
			
			self:AdminCurrentAuctionSync(value, author)
			
--~ Author wird nach Bietzeit gefragt
		elseif key == addonMSG.getbidtime and dbn.auctionAuthor == PLAYERNAME then			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r SEND - Send interpellate for Bidtime to ["..cauthor.."].")
			end
			
			self:AdminCurrentAuctionSend(author, typ)
			
--~ Gebot von Player kommt rein
		elseif key == addonMSG.bidpoint then			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Bid from ["..cauthor.."] incomig.")
			end
			
			self:IncomingNewBid(value, author)
			
--~ Pass von Player kommt rein
		elseif key == addonMSG.sendpassbid then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Bid for ["..cauthor.."] withdraw.")
			end
			
			self:IncomingPassLastBid(value, author)
			
--~ VersteigerungsDatenVergleich incoming
		elseif key == addonMSG.sendauctiondata then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - AuctionData from ["..cauthor.."] incomig.")
			end
			
			self:IncomingAuctionDATA(value, author)
			
--~ VersteigerungsDatenVergleich send
		elseif key == addonMSG.getauctiondata then
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r SEND - AuctionData from ["..cauthor.."] submitted and to you send.")
			end
			
			if self.auctionStatusSTART then
				local auctionDATA = self:Serialize(addonMSG.sendauctiondata, dbn.itemID, dbn.auctionAuthor, dbn.channel, dbn.last.BidName, dbn.last.BidPoint, dbn.last.BidTime, dbn.last.BidArt, dbn.last.BidU80, (dba.bidderShow and false or dbn.last.IsName))
				self:SendAddonMSG(auctionDATA, "WHISPER", author)
			end
			
--~ Fehlgebot incoming
		elseif key == addonMSG.sendfalsebid then			
			if dbc.debugmodus or dbc.debugadmin then
				self:Print("|cff5555ffDEBUG "..typ..":|r INC - Errorreport from ["..cauthor.."] incoming.")
			end
			
			_, _, value = self:Deserialize(value)			
			self:FalseBidAuction(value, author)
			
		end
	end
end


---------------------------------------
--~ SendMessages
---------------------------------------
function GigaItemAuction:SendAddonMSG(serialdata, channel, player)
	local dbn = db.nowAuction
	local channel = channel or dbn.channel
	local channels = {["RAID"]=true,["GUILD"]=true,["WHISPER"]=true}
	local player = player or dbn.auctionAuthor or nil
	if not channels[channel] then self:Print("|cffff5555ERROR:|r SendCommMessage: setChannel") return end
	
	self:SendCommMessage(self.amsg.prefix, serialdata, channel, channel == "WHISPER" and player or nil)
end

function GigaItemAuction:Whisper(player, text, noprefix)
	local PreText = noprefix and "" or "GIA: "
	local msg = ""
	if player and text then
		msg = PreText..text
		sentWhispers[msg] = true
		SendChatMessage(msg, "WHISPER", GetLanguageByIndex(0), player)
	end
end